(function () {
  try {
    return angular.module('bonitasoft.ui.widgets');
  } catch(e) {
    return angular.module('bonitasoft.ui.widgets', []);
  }
})().directive('customToggleButtons', function() {
    return {
      controllerAs: 'ctrl',
      controller: function PbRadioBoxCtrl($scope, $parse, $log, widgetNameFactory,uiTranslateFilter) {

  'use strict';
  var ctrl = this;
  /**
   * Watch the data source and set wrapChoices and $scope.properties.values
   */
  function comparator(initialValue, item) {
    return angular.equals(initialValue, ctrl.getValue(item));
  }

  function createGetter(accessor) {
    return accessor && $parse(accessor);
  }

  this.getToogleClass = function(option)  {
    if (option[ $scope.properties.returnedKey ] === $scope.properties.selectedValue)
        return 'btn btn-' + $scope.properties.buttonStyleSelected
    return 'btn btn-' + $scope.properties.buttonStyle;
  }
  
  this.getLabel = createGetter($scope.properties.displayedKey) || function (item) {
    return uiTranslateFilter(typeof item === 'string' ? item : JSON.stringify(item));
  };
  this.getValue = createGetter($scope.properties.returnedKey) || function (item) {
    return item;
  };

  $scope.$watch('properties.availableValues', function(items){
    if (Array.isArray(items)) {
      var foundValue = items
        .filter(comparator.bind(null, $scope.properties.selectedValue))
        .reduce(function (acc, item) {
          return ctrl.getValue(item);
        }, undefined);
      if (foundValue) {
          console.log("ToggleButton - foundValue ["+foundValue+"]")
        $scope.properties.selectedValue = foundValue;
      }
    }
  });
  
  this.name = widgetNameFactory.getName('customToggleButtons');

  if (!$scope.properties.isBound('selectedValue')) {
    $log.error('the customToggleButtons property named "selectedValue" need to be bound to a variable');
  }

  
}
,
      template: '<div class="text-{{ properties.alignment }}">\n<div class="form-horizontal">\n    <div class="form-group">\n        <div class="col-xs-{{ 12 - (!properties.labelHidden && properties.labelPosition === \'left\' ? properties.labelWidth : 0) }}">\n           <div class="btn-group">\n            <label ng-class="ctrl.getToogleClass(option)"\n                   ng-model="properties.selectedValue"\n                   ng-repeat="option in properties.availableValues track by $index" \n                   uib-btn-radio="ctrl.getValue(option)"\n                   ng-bind-html="ctrl.getLabel(option)">\n            </label>\n            </div>\n        </div>\n        <div ng-messages="$form[ctrl.name].$dirty && $form[ctrl.name].$error " ng-messages-include="forms-generic-errors.html" role="alert"></div>\n        \n    </div>\n</div>\n</div>'
    };
  });
